#include <QApplication>
#include <QFileDialog>
#include <QLabel>
#include <QDebug>
#include <QTimer>

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    QFileDialog fileDialog;
    QLabel label;

    QObject::connect(&fileDialog, &QFileDialog::rejected, []() {
        qDebug() << "Rejected";
        QTimer::singleShot(0, QApplication::quit);
    });
    QObject::connect(&fileDialog, &QFileDialog::accepted, [&fileDialog, &label]() {
        qDebug() << "Accepted";
        label.setText(fileDialog.selectedFiles().join(", "));
        label.adjustSize();
    });

    fileDialog.setOption(QFileDialog::DontUseNativeDialog);
    fileDialog.setFileMode(QFileDialog::ExistingFiles);

    label.show();
    fileDialog.show();

    QTimer::singleShot(0, [](){
        QFileDialog modalF;
        modalF.setOption(QFileDialog::DontUseNativeDialog);
        modalF.setFileMode(QFileDialog::ExistingFiles);
        modalF.exec();
    });

    return a.exec();
}
